<?php
//----------------------------------------------------------------------------//
    function Get_Domain_Name ( $User )
    {
        $Contents = '' ;
        if ( is_file ( $GLOBALS['Constants']['Paths']['cPanel']['Users'] . $User ) )
        {
            $Contents = file ( $GLOBALS['Constants']['Paths']['cPanel']['Users'] . $User ) ;
        }
        $Domain_Name   = '' ;
        if ( TRUE === empty ( $Contents ) )
        {
        }
        else
        {
            foreach ( $Contents as $Line )
            {
                if ( ereg ( '^DNS=' , $Line ) )
                {
                    $Domain_Name = substr ( strstr ( $Line , '=' ) , 1 ) ;
                }
            }
        }
        return trim ( $Domain_Name ) ;
    }
//----------------------------------------------------------------------------//
    function Get_Home_Directory ( $Domain_Name )
    {
        $Domain_Name = trim ( $Domain_Name ) ;
        $Home_Directory = '' ;
        if ( is_file ( $GLOBALS['Constants']['Paths']['cPanel']['httpd.conf'] ) )
        {
            $Contents = file_get_contents ( $GLOBALS['Constants']['Paths']['cPanel']['httpd.conf'] ) ;
            $Temporary = preg_match_all ( '#<VirtualHost([^>]*)>(.*)</VirtualHost>#Uisx' , $Contents , $Matches , PREG_SET_ORDER ) ;
            if ( !empty ( $Matches ) )
            {
                foreach ( $Matches As $Match )
                {
                    if ( !empty ( $Match[2] ) )
                    {
                        $Match[2] = explode ( "\n" , $Match[2] ) ;
                        if ( !empty ( $Match[2] ) )
                        {
                            foreach ( $Match[2] As $Key => $Value )
                            {
                                $Value = trim ( $Value ) ;
                                if ( eregi ( '^ServerAlias' , $Value ) OR eregi ( '^ServerName' , $Value ) )
                                {
                                    $Value = explode ( ' ' , $Value ) ;
                                    if ( !empty ( $Value ) )
                                    {
                                        foreach ( $Value As $_Domain_Name )
                                        {
                                            $_Domain_Name = trim ( $_Domain_Name ) ;
                                            if ( $Domain_Name == $_Domain_Name )
                                            {
                                                foreach ( $Match[2] As $Key => $Value )
                                                {
                                                    $Value = trim ( $Value ) ;
                                                    if ( eregi ( '^DocumentRoot' , $Value ) )
                                                    {
                                                        $Home_Directory = $Value ;
                                                        $Home_Directory = str_replace ( 'DocumentRoot ' , '' , trim ( $Home_Directory ) ) ;
                                                        $Home_Directory = str_replace ( 'public_html'   , '' , trim ( $Home_Directory ) ) ;
                                                        if ( substr ( $Home_Directory , -1 ) != '/' )
                                                        {
                                                            $Home_Directory .= '/' ;
                                                        }
                                                    }
                                                }
                                                break 3 ;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        return $Home_Directory ;
    }
//----------------------------------------------------------------------------//
    function Get_Installation_Overview ( $Registry_Directory , $Registry_File , $Domain_Name , $Home_Directory )
    {
        if ( is_file ( $Registry_Directory . '/' . $Registry_File ) )
        {
            // include $Registry_Directory . '/' . $Registry_File ;
            list ( $thisdb , $thisdomain , $thisscriptpath ) = parse_registry ( $Registry_Directory . '/' . $Registry_File ) ;
            $Directory = $thisscriptpath ;
        }
        $Link           = '' ;
        $Title          = '' ;
        $Version_Number = '' ;
        $Class          = '' ;
        if ( strstr ( $Registry_File , '|' ) )
        {
            $Registry_File    = explode ( '|' , $Registry_File ) ;
            $Registry_File[0] = trim ( $Registry_File[0] )       ;
            $Registry_File[1] = trim ( $Registry_File[1] )       ;
            if ( $Registry_File[0] == $Domain_Name )
            {
                $Title = '/' . $Registry_File[1] ;
                $Link = $Domain_Name . '/' . $Registry_File[1] ;
            }
            else
            {
                $Title = $Registry_File[0] . '/' . $Registry_File[1] ;
                $Link = $Registry_File[0] . '/' . $Registry_File[1] ;
            }
        }
        else
        {
            $Title = '/' . $Registry_File  ;
            $Link  = $Domain_Name . '/' . $Registry_File ;
        }
        $Version_Number = '<strong>(unknown)</strong>' ;
        if ( $Directory != '' )
        {
            if ( is_file ( $Directory . '/fantversion.php' ) )
            {
                // include $Directory . '/fantversion.php' ;
                list ( $version ) = parse_fantversion ( $Directory . '/fantversion.php' ) ;
                $Version_Number = $version ;

                $Latest_Version_Number = Get_Latest_Version ( $GLOBALS['Script'] ) ;

                if ( $Latest_Version_Number != $Version_Number )
                {
                    $Version_Number = $Version_Number . ' (' . $Latest_Version_Number . ')' ;
                    $Class = 'Update' ;
                }

            }
            else
            {
                $Command = 'ls "' . $Directory . '" 2>&1' ;
                $Output  = Get_Output ( $Command , 'Off' ) ;
                if ( stristr ( $Output , 'Permission denied' ) )
                {
                    $Version_Number = '<span class="Success"><strong>(X)</strong></span>' ;
                }
                else
                {
                    $Version_Number = '<span class="Failure"><strong>(X)</strong></span>' ;
                }
            }
        }
        else
        {
            if ( is_file ( $Home_Directory . 'public_html/' . $Link . '/fantversion.php' ) )
            {
                // include $Home_Directory . 'public_html/' . $Link . '/fantversion.php' ;
                list ( $version ) = parse_fantversion ( $Home_Directory . 'public_html/' . $Link . '/fantversion.php' ) ;
                $Version_Number = $version ;

                $Latest_Version_Number = Get_Latest_Version ( $GLOBALS['Script'] ) ;

                if ( $Latest_Version_Number != $Version_Number )
                {
                    $Version_Number = $Version_Number . ' (' . $Latest_Version_Number . ')' ;
                    $Class = 'Update' ;
                }

            }
            else
            {
                $Command = 'ls "' . $Home_Directory  . 'public_html' . $Link . '" 2>&1' ;
                $Output  = Get_Output ( $Command , 'Off' ) ;
                if ( stristr ( $Response , 'Permission denied' ) )
                {
                    $Version_Number = '<span class="Success"><strong>(X)</strong></span>' ;
                }
                else
                {
                    $Version_Number = '<span class="Failure"><strong>(X)</strong></span>' ;
                }
            }
        }
        $Overview['Link'          ] = $Link           ;
        $Overview['Title'         ] = $Title          ;
        $Overview['Version_Number'] = $Version_Number ;
        $Overview['Class'         ] = $Class          ;
        /* Debugging */ // echo Get_Variable_Dump ( $Overview ) ;
        return $Overview ;
    }
//----------------------------------------------------------------------------//
    function Get_Installation_Overview_Template ( $Index , $URL , $Title , $Version_Number , $Class )
    {
//----------------------------------------------------------------------------//
?>
        <tr class="<?php echo $Class ; ?>">
            <td class="Narrow"><?php echo $Index ; ?></td>
            <td class="Broad"><a href="http://<?php echo $URL ; ?>" title="<?php echo $Title ; ?>" target="_blank"><?php echo $Title ; ?></a></td>
            <td class="Narrow Right"><?php echo $Version_Number ; ?></td>
        </tr>
<?php
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
    function Get_Primary_Header_Template ( $Content )
    {
//----------------------------------------------------------------------------//
?>
        <tr>
            <td colspan="4" class="Primary_Header"><span class="Success"><strong><?php echo $Content ; ?></strong></span></td>
        </tr>
<?php
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
    function Get_Secondary_Header_Template ( $Content )
    {
//----------------------------------------------------------------------------//
?>
        <tr>
            <td colspan="4" class="Secondary_Header"><strong><?php echo $Content ; ?></strong></td>
        </tr>
<?php
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
    function Get_Content_Template ( $Content )
    {
//----------------------------------------------------------------------------//
?>
        <tr>
            <td colspan="4" class="Content"><?php echo $Content ; ?></td>
        </tr>
<?php
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
    function Get_Error_Template ( $Content )
    {
//----------------------------------------------------------------------------//
?>
        <tr>
            <td colspan="4"><span class="Failure"><strong><?php echo $Content ; ?></strong></span></td>
        </tr>
<?php
//----------------------------------------------------------------------------//
    }
//----------------------------------------------------------------------------//
?>
